#! /usr/bin/perl
#Name: lander-client.perl
#Project: Lander control
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 03.01.2012
#Copyright: (c) 2011 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Client script for lander-server.perl. Both scripts are used to operate a remote controlled "lander module" and to do the picture upload from the webcam.
#See www.HomoFaciens.de for details

use strict;
use IO::Socket;

$|=1 ;

my $socket;
my $send_data = "";
my $received_data;
my $pic_count = 0;
my $file_in = "00000010.jpg";
my $char_in = "";
my $i;
my @file_info;
my $file_size = 0;
my $char_temp = "";
my $command_start_time = 0;
my $command_stop_time = 10;
my $job_status = 0;
my $wait_count = 0;
my $hightAngle = 6;
my $horizontalAngle = 6;
my $verticalAngle = 6;
my $last_pic_send = 0;
my $make_snapshot = 0;
my $last_watchdog_call = 0;
my $brightness = 30;
my $contrast = 10;
my $saturation = 20;
my $pic_save_nr = time();



$socket = new IO::Socket::INET (
                                  PeerAddr  => 'www.XYZ.de',   #Type the domainname or the IP adress of your Internet server here
                                  PeerPort  =>  1101,          #Must be the same port as in 'lander-server.perl'!
                                  Proto => 'tcp',
                               )
or die "Couldn't connect to Server\n";

$pic_count = 0;

$send_data = "";
$send_data = substr("TypeYourPasswordHere" . "                                 ", 0, 33);
$socket->send($send_data, 33);


while (1 == 1){

  &WatchDogFile(0);

  if($job_status != 0){

#Use mplayer or ffmpeg to get a single image from the webcam. 10 pics are generated to give the wabcam some time to autoadjust the brightness.

#    `killall -s SIGKILL ffmpeg`;
    #`killall -s SIGKILL mplayer`;
    #&ExecuteCommandLine("mplayer tv:// -tv driver=v4l2:device=/dev/video0:width=640:height=480:brightness=$brightness:contrast=$contrast:saturation=$saturation:outfmt=rgb24:quality=5 -frames 10 -vo jpeg");
    #&ExecuteCommandLine("ffmpeg -f video4linux2 -s 640x480 -r 5 -t 5 -qscale 5 -i /dev/video0 %08d.jpg");
    if(-e "/usb/LanderPics/MakePics.txt"){#Save high resolution camera pics to USB stick if stick is mounted
      &ExecuteCommandLine("mplayer tv:// -tv driver=v4l2:device=/dev/video0:width=640:height=480:outfmt=rgb24:quality=5 -frames 10 -vo jpeg");
      for($i=1;$i<11;$i++){
        if($i<10){
          &ExecuteCommandLine("cp 0000000" . $i . ".jpg /usb/LanderPics/" . $pic_save_nr . ".jpg");
        }
        else{
          &ExecuteCommandLine("cp 000000" . $i . ".jpg /usb/LanderPics/" . $pic_save_nr . ".jpg");
        }
        $pic_save_nr++;
      }
      &ExecuteCommandLine("ffmpeg -i $file_in -s 320x240 $file_in");
    }
    else{
      &ExecuteCommandLine("mplayer tv:// -tv driver=v4l2:device=/dev/video0:width=640:height=480:outfmt=rgb24:quality=5 -frames 10 -vo jpeg");
      `ffmpeg -i 00000010.jpg -s 800x600 LastLanderPic.jpg`;
      if(!($last_pic_send == 1 && $make_snapshot == 1)){
        `ffmpeg -i LastLanderPic.jpg -s 320x240 00000010.jpg`;
      }
    }

    @file_info=stat($file_in);
    $file_size = $file_info[7];

    $send_data = "";

    $send_data = "File size = " . $file_size . "                    ";
    $send_data = substr($send_data, 0, 20);

    $socket->send($send_data, 20);

    print "'" . $send_data . "' Laenge String=" . length($send_data) . "\n";

    #Open image file and start transfer to server
    open(FILEIN, '<' . $file_in) || die "Can not open file $file_in: $!";
      $i = 0;
      $send_data = "";
      while(($char_in = getc(FILEIN)) ne "" && $file_size > 0){
        &WatchDogFile(0);
        $send_data = $send_data . $char_in;
        $i++;
        if($i == 1024 || $i == $file_size){
          if ($file_size < 1024){
            while(length($send_data)<1024){
              $send_data = $send_data . " ";
            }
            $socket->send($send_data, 1024);
            $send_data = "";
            $i = 0;
            $file_size = 0;
          }
          else{
            $socket->send($send_data, 1024);
            $send_data = "";
            $i = 0;
            $file_size -= 1024;
          }
        }
      }
    close(FILEIN);

    $pic_count++;

    print "File no. " . $pic_count . " sent, waiting for confirmation...\n";

    $socket->recv($received_data, 20, MSG_WAITALL);
    if(substr($received_data, 0, 16) eq "Received picture"){
      print "'" . $received_data . "'  ";
      print "...confirmed\n\n\n";
    }
    else{
      print "received_data = '" . $received_data . "'\n";
      &LogFile ("...confirmation of received picture failed!");
      die "...confirmation failed!\n";
    }
    #sleep(2);#Do nothing for 2 seconds to keep data transfer rate low (I still need bandwidth of my Internet connection for some other stuff).
  }#if($job_status != 0){

  if($command_start_time != 0){
    if(time()-$command_start_time < $command_stop_time){
      $send_data = "Busy                ";
      $socket->send($send_data, 20);
      print "Send:'" . $send_data . "'\n";
    }
    else{
      if($last_pic_send == 0){#send last pic after command finished
        $send_data = "Busy                ";
        $socket->send($send_data, 20);
        print "Send:'" . $send_data . "'\n";
        $last_pic_send = 1;
      }
      else{
        $send_data = "Job done            ";
        $socket->send($send_data, 20);
        print "Send:'" . $send_data . "'\n";
        $command_start_time = 0;
        $job_status=0;
        $last_pic_send = 0;
      }
    }
  }
  else{
    $send_data = "Waiting             ";
    $socket->send($send_data, 20);
    print "Send:'" . $send_data . "'\n";

    $received_data = "";
    $socket->recv($received_data, 20, MSG_WAITALL);

    while(substr($received_data, 0, 12) eq "Still alive?"){

      if($wait_count == 0){
        &ExecuteCommandLine("./LanderControl a 59");                  #set lander in parking position
        &ExecuteCommandLine("./LanderControl h 79");
        &ExecuteCommandLine("./LanderControl v 71");
        &ExecuteCommandLine("./LanderControl l 0");
      }
      else{
        #Turn off serv0s
        &ExecuteCommandLine("./LanderControl a 0");
        &ExecuteCommandLine("./LanderControl h 0");
        &ExecuteCommandLine("./LanderControl v 0");
      }


      $wait_count ++;
      print "wait_count = $wait_count\n";
      $send_data="Yes!                ";
      $socket->send($send_data, 20);
      print "Send:'" . $send_data . "'\n";
      &WatchDogFile(0);
      $received_data = "";
      $socket->recv($received_data, 20, MSG_WAITALL);
      print "received_data = '" . $received_data . "'\n";
    }

    if(substr($received_data, 0, 5) eq "Comm="){
      $wait_count = 0;
      print "\n\nReceived command '" . $received_data . "'\n\n";

      $hightAngle = substr($received_data, 6, 2);
      if($hightAngle < 1 | $hightAngle > 30){
        print "hightAngle=$hightAngle out of range (1 - 30)!\n";
        $hightAngle = 6;
      }
      $hightAngle = sprintf("%.0f", 52 * $hightAngle / 30 + 33);
      &ExecuteCommandLine("./LanderControl a " . $hightAngle);

      $horizontalAngle = substr($received_data, 8, 2);
      if($horizontalAngle < 1 | $horizontalAngle > 30){
        print "horizontalAngle=$horizontalAngle out of range (1 - 30)!\n";
        $horizontalAngle = 19;
      }
      $horizontalAngle = sprintf("%.0f", 62 * $horizontalAngle / 30 + 48);
      &ExecuteCommandLine("./LanderControl h " . $horizontalAngle);

      $verticalAngle = substr($received_data, 10, 2);
      if($verticalAngle < 1 | $verticalAngle > 30){
        print "verticalAngle=$verticalAngle out of range (1 - 30)!\n";
        $verticalAngle = 6;
      }
      $verticalAngle = sprintf("%.0f", 78 * $verticalAngle / 30 + 32);
      &ExecuteCommandLine("./LanderControl v " . $verticalAngle);

      if(substr($received_data, 12, 1) eq "0"){#Light off
        &ExecuteCommandLine("./LanderControl l 0");
      }
      if(substr($received_data, 12, 1) eq "1"){#Light low
        &ExecuteCommandLine("./LanderControl l 20");
      }
      if(substr($received_data, 12, 1) eq "2"){
        &ExecuteCommandLine("./LanderControl l 80");
      }
      if(substr($received_data, 12, 1) eq "3"){
        &ExecuteCommandLine("./LanderControl l 100");
      }
      if(substr($received_data, 12, 1) eq "4"){#Light high
        &ExecuteCommandLine("./LanderControl l 200");
      }

      if(substr($received_data, 13, 1) eq "1"){#make snapshot
        $make_snapshot = 1;
      }
      else{
        $make_snapshot = 0;
      }

      $job_status=1;
      $command_start_time=time();
    }#if(substr($received_data, 0, 5) eq "Comm=")
    else{
      &LogFile("Invalid commandline!");
      die "Invalid commandline!\n"
    }
  }

}#while (1 == 1)

close $socket;


#++++++++++++++++++++++++ LogFile ++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub LogFile{

  @file_info=stat("lander-client.log");

  $char_temp=substr(time() . "                    ", 0, 20);

  if ($file_info[7] > 1000000){
    `mv lander-client.log lander-client01.log`
  }

  open(LOGFILE, ">> lander-client.log") || die "Can not open file 'lander-client.log'!\n";
    print LOGFILE $char_temp . $_[0] . "\n";
  close(LOGFILE);

}

#++++++++++++++++++++++ ExecuteCommandLine ++++++++++++++++++++++++++++++++++++++++++++++++++
sub ExecuteCommandLine{
  print "command=" . $_[0] . "\n";
  `$_[0]`;
}


#++++++++++++++++++++++ WatchDogFile +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub WatchDogFile{#Print a timestamp into a file to show watchdog-client.perl that script is still alive
  if(time() - $last_watchdog_call > 10){
    open(WATCHDOGFILE, "> watchdog-client.tmp") || die "Can not open file 'watchdog-client.tmp'!\n";
      print WATCHDOGFILE time() . "\n";
    close(WATCHDOGFILE);
    if($_[0] == 0){
      `mv watchdog-client.tmp watchdog-client.txt`;
    }
    $last_watchdog_call = time();
  }
}

